<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>celtool/camera.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">celtool/camera.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2005 by Jorrit Tyberghein</span>
<a name="l00004"></a>00004 <span class="comment"></span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.</span>
<a name="l00018"></a>00018 <span class="comment">*/</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __CEL_PF_CAMFACT__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_PF_CAMFACT__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;celtool/celtoolextern.h&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cstypes_8h.html">cstypes.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scf_8h.html">csutil/scf.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;physicallayer/propclas.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;physicallayer/propfact.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;physicallayer/facttmpl.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;celtool/stdpcimp.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/reporter_8h.html">ivaria/reporter.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;propclass/camera.h&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">struct </span><a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>;
<a name="l00034"></a>00034 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiObjectRegistry.html">iObjectRegistry</a>;
<a name="l00035"></a>00035 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiGraphics3D.html">iGraphics3D</a>;
<a name="l00036"></a>00036 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiEngine.html">iEngine</a>;
<a name="l00037"></a>00037 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiVirtualClock.html">iVirtualClock</a>;
<a name="l00038"></a>00038 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiCamera.html">iCamera</a>;
<a name="l00039"></a>00039 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiPerspectiveCamera.html">iPerspectiveCamera</a>;
<a name="l00040"></a>00040 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiView.html">iView</a>;
<a name="l00041"></a>00041 <span class="keyword">struct </span><a class="code" href="structiPcRegion.html" title="The representation of a region.">iPcRegion</a>;
<a name="l00042"></a>00042 <span class="keyword">struct </span><a class="code" href="structiPcZoneManager.html" title="This is the zone manager.">iPcZoneManager</a>;
<a name="l00043"></a>00043 <span class="keyword">class </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsView.html">csView</a>;
<a name="l00044"></a>00044 
<a name="l00048"></a><a class="code" href="structcelPcCameraCommon.html">00048</a> <span class="keyword">struct </span>CEL_CELTOOL_EXPORT <a class="code" href="structcelPcCameraCommon.html" title="The representation of a camera.">celPcCameraCommon</a> : <span class="keyword">public</span> <a class="code" href="classcelPcCommon.html" title="This is a common implementation for a property class from which all other property classes can inheri...">celPcCommon</a>
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050 <span class="keyword">protected</span>:
<a name="l00051"></a>00051   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRef.html">csRef&lt;iGraphics3D&gt;</a> g3d;
<a name="l00052"></a>00052   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRef.html">csRef&lt;iEngine&gt;</a> engine;
<a name="l00053"></a>00053   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRef.html">csRef&lt;iVirtualClock&gt;</a> vc;
<a name="l00054"></a>00054   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRef.html">csRef&lt;iView&gt;</a> view;
<a name="l00055"></a>00055   <span class="keywordtype">bool</span> rect_set;
<a name="l00056"></a>00056   <span class="keywordtype">int</span> rect_x, rect_y, rect_w, rect_h;
<a name="l00057"></a>00057   <span class="keywordtype">bool</span> center_set;
<a name="l00058"></a>00058   <span class="keywordtype">float</span> center_x, center_y;
<a name="l00059"></a>00059 
<a name="l00060"></a>00060   <span class="comment">// Fields for the far plane.</span>
<a name="l00061"></a>00061   <span class="keyword">struct</span>
<a name="l00062"></a>00062   {
<a name="l00063"></a>00063 <span class="preprocessor">#define FP_MAX_DIST 10000.0     // Maximum visibile distance.</span>
<a name="l00064"></a>00064 <span class="preprocessor"></span><span class="preprocessor">#define FP_INIT_DIST 200.0      // We start from this value.</span>
<a name="l00065"></a>00065 <span class="preprocessor"></span>    <span class="keywordtype">bool</span> use_farplane;          <span class="comment">// If true then we use a farplane.</span>
<a name="l00066"></a>00066     <span class="keywordtype">float</span> fixed_distance;       <span class="comment">// If &lt; 0 then we use adaptive system.</span>
<a name="l00067"></a>00067     <span class="comment">// All fields below are for adaptive only.</span>
<a name="l00068"></a>00068     <span class="keywordtype">float</span> min_fps, max_fps;     <span class="comment">// Acceptable FPS interval.</span>
<a name="l00069"></a>00069     <span class="keywordtype">float</span> min_dist;             <span class="comment">// Minimum acceptiable distance.</span>
<a name="l00070"></a>00070     <span class="keywordtype">bool</span> fps_valid;             <span class="comment">// First frame we don&#39;t know fps yet.</span>
<a name="l00071"></a>00071     <span class="keywordtype">float</span> smooth_fps;           <span class="comment">// To have less chaotic FPS changes.</span>
<a name="l00072"></a>00072     <span class="keywordtype">float</span> current_distance;     <span class="comment">// Remember current distance.</span>
<a name="l00073"></a>00073     <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> accumulated_elapsed;<span class="comment">// Accumulated elapsed time.</span>
<a name="l00074"></a>00074   } fp;
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsWeakRef.html">csWeakRef&lt;iPcRegion&gt;</a> region;
<a name="l00077"></a>00077   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsWeakRef.html">csWeakRef&lt;iPcZoneManager&gt;</a> zonemgr;
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 <span class="keyword">public</span>:
<a name="l00080"></a>00080   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gafafd40981020e10aab24694b52229e74">Report</a>(<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiObjectRegistry.html">iObjectRegistry</a>* reg, <span class="keyword">const</span> <span class="keywordtype">char</span>* msg, ...);
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   <a class="code" href="structcelPcCameraCommon.html" title="The representation of a camera.">celPcCameraCommon</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiObjectRegistry.html">iObjectRegistry</a>* object_reg);
<a name="l00083"></a>00083   <span class="keyword">virtual</span> ~<a class="code" href="structcelPcCameraCommon.html" title="The representation of a camera.">celPcCameraCommon</a> ();
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="keywordtype">bool</span> SetRegion (<a class="code" href="structiPcRegion.html" title="The representation of a region.">iPcRegion</a>* region, <span class="keywordtype">bool</span> point, <span class="keyword">const</span> <span class="keywordtype">char</span>* name);
<a name="l00086"></a>00086   <span class="keywordtype">bool</span> SetZoneManager (<a class="code" href="structiPcZoneManager.html" title="This is the zone manager.">iPcZoneManager</a>* zonemgr, <span class="keywordtype">bool</span> point,
<a name="l00087"></a>00087         <span class="keyword">const</span> <span class="keywordtype">char</span>* regionname, <span class="keyword">const</span> <span class="keywordtype">char</span>* name);
<a name="l00088"></a>00088   <span class="keywordtype">bool</span> SetZoneManager (<span class="keyword">const</span> <span class="keywordtype">char</span>* entityname, <span class="keywordtype">bool</span> point,
<a name="l00089"></a>00089         <span class="keyword">const</span> <span class="keywordtype">char</span>* regionname, <span class="keyword">const</span> <span class="keywordtype">char</span>* name);
<a name="l00090"></a>00090   <span class="keywordtype">void</span> SetRectangle (<span class="keywordtype">int</span> x, <span class="keywordtype">int</span> y, <span class="keywordtype">int</span> w, <span class="keywordtype">int</span> h);
<a name="l00091"></a>00091   <span class="keywordtype">void</span> SetPerspectiveCenter (<span class="keywordtype">float</span> x, <span class="keywordtype">float</span> y);
<a name="l00092"></a>00092 
<a name="l00093"></a>00093   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiCamera.html">iCamera</a>* GetCamera () <span class="keyword">const</span>;
<a name="l00094"></a>00094   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiPerspectiveCamera.html">iPerspectiveCamera</a>* GetPerspectiveCamera () <span class="keyword">const</span>;
<a name="l00095"></a>00095   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiView.html">iView</a>* GetView ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> view; }
<a name="l00096"></a>00096 
<a name="l00097"></a>00097   <span class="comment">// For distance clipping.</span>
<a name="l00098"></a>00098   <span class="keywordtype">void</span> SetDistanceClipping (<span class="keywordtype">float</span> dist);
<a name="l00099"></a>00099   <span class="keywordtype">void</span> AdaptDistanceClipping (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> elapsed_time);
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   <span class="keywordtype">void</span> DisableDistanceClipping ();
<a name="l00102"></a>00102   <span class="keywordtype">void</span> EnableFixedDistanceClipping (<span class="keywordtype">float</span> dist);
<a name="l00103"></a>00103   <span class="keywordtype">void</span> EnableAdaptiveDistanceClipping (<span class="keywordtype">float</span> min_fps,
<a name="l00104"></a>00104         <span class="keywordtype">float</span> max_fps, <span class="keywordtype">float</span> min_dist);
<a name="l00105"></a>00105   <span class="keywordtype">bool</span> UseDistanceClipping ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> fp.use_farplane; }
<a name="l00106"></a>00106   <span class="keywordtype">bool</span> UseFixedDistanceClipping ()<span class="keyword"> const</span>
<a name="l00107"></a>00107 <span class="keyword">  </span>{
<a name="l00108"></a>00108     <span class="keywordflow">return</span> fp.use_farplane &amp;&amp; fp.fixed_distance &gt;= 0.0f;
<a name="l00109"></a>00109   }
<a name="l00110"></a>00110   <span class="keywordtype">float</span> GetFixedDistance ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> fp.fixed_distance; }
<a name="l00111"></a>00111   <span class="keywordtype">float</span> GetAdaptiveMinFPS ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> fp.min_fps; }
<a name="l00112"></a>00112   <span class="keywordtype">float</span> GetAdaptiveMaxFPS ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> fp.max_fps; }
<a name="l00113"></a>00113   <span class="keywordtype">float</span> GetAdaptiveMinDistance ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> fp.min_dist; }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   <span class="keywordtype">void</span> SetAutoDraw (<span class="keywordtype">bool</span> auto_draw);
<a name="l00116"></a>00116 
<a name="l00121"></a>00121   <span class="keywordtype">void</span> SaveCommon (<a class="code" href="structiCelDataBuffer.html" title="This interface describes persistable data.">iCelDataBuffer</a>* databuf);
<a name="l00126"></a>00126   <span class="keywordtype">bool</span> LoadCommon (<a class="code" href="structiCelDataBuffer.html" title="This interface describes persistable data.">iCelDataBuffer</a>* databuf);
<a name="l00127"></a>00127 
<a name="l00128"></a>00128   <span class="keyword">virtual</span> <span class="keywordtype">void</span> Draw ();
<a name="l00129"></a>00129 
<a name="l00130"></a>00130   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;iCelDataBuffer&gt;</a> Save ();
<a name="l00131"></a>00131   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> Load (<a class="code" href="structiCelDataBuffer.html" title="This interface describes persistable data.">iCelDataBuffer</a>* databuf);
<a name="l00132"></a>00132   <span class="keyword">virtual</span> <span class="keywordtype">void</span> TickEveryFrame ();
<a name="l00133"></a>00133 };
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 <span class="preprocessor">#endif // __CEL_PF_CAMFACT__</span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
